const app = getApp()
import { Base } from '../../utils/base.js';
import apiList from '../../utils/apiList';
const base = new Base();
Page({

    /**
     * 页面的初始数据
     */
    data: {
        endLoading: false,
        list: [],
        next_page: 1, // 下一页
        has_more: true, // 是否还有更多 
        locked: false,
        limit: 10,
        roomId: '',//房间号
    },

    /**
     * 生命周期函数--监听页面加载
     */
    onLoad: function (options) {
        this.getList()
    },
    getList() {
        let params = {
            url: apiList.live_list,
            type: "GET",
            data: {
                page: this.data.next_page,
                limit: this.data.limit
            },
            callback: (data) => {
                console.log('list', data)
                this.setData({
                    endLoading: true,
                    list: this.data.next_page == 1 ? data.list : this.data.list.concat(data.list),
                    has_more: data.more,
                    next_page: data.page,
                    locked: false,
                })
            },
        }
        wx.showLoading({
            title: '努力加载中...',
        })
        base.newRequest(params)
    },
    goLive(e) {
        // console.log(e.currentTarget.dataset.roomid)
        let roomId = e.currentTarget.dataset.roomid // 房间号
        try {
            var userInfo = wx.getStorageSync('userInfo')
            if (userInfo) {
                let customParams = {
                    isCode: true
                }
                wx.navigateTo({
                    url: `plugin-private://wx2b03c6e691cd7370/pages/live-player-plugin?room_id=${roomId}&custom_params=${encodeURIComponent(JSON.stringify(customParams))}`
                })
            } else {
                app.globalData.backurl = '/pages/translate/translate'
                wx.navigateTo({
                    url: '/pages/login/index/index',
                })
            }
        } catch (e) { }
    },
    // 开启订阅通知
    impower(e) {
        this.setData({
            roomId: e.currentTarget.dataset.roomid
        })
        let that = this
        try {
            var userInfo = wx.getStorageSync('userInfo')
            if (userInfo) {
                wx.requestSubscribeMessage({
                    tmplIds: ["FPC0l1-MagGKXvER1IArYg_n8AoVVCLiCn4guPKctGM"],
                    success: function (res) {
                        console.log(res)
                        if (res["FPC0l1-MagGKXvER1IArYg_n8AoVVCLiCn4guPKctGM"] === 'accept') {
                            that.meetLive()
                        }
                    },
                    fail: function (res) {
                        console.log(res)
                    }
                })
            } else {
                app.globalData.backurl = '/pages/translate/translate'
                wx.navigateTo({
                    url: '/pages/login/index/index',
                })
            }
        } catch (e) { }
        
    },
    // 开播提醒预约
    meetLive: function () {
        let params = {
            url: apiList.live_reverse,
            type: "POST",
            data: {
                meeting_live_id: this.data.roomId
            },
            callback: (data) => {
                base.toast("订阅成功")
            },
        }
        wx.showLoading({
            title: '努力加载中...',
        })
        base.newRequest(params)
    },
    initData: function () {
        this.setData({
            endLoading: false,
            list: [],
            has_more: true,
            next_page: 1,
            locked: false
        })
    },
    onPullDownRefresh: function () {
        this.initData()
        if (!this.data.locked) {
            this.setData({
                locked: true
            })
            this.getList()
        }
        wx.stopPullDownRefresh()
    },
    onReachBottom: function () {
        if (!this.data.locked && this.data.has_more) {
            this.setData({
                locked: true
            })
            this.getList()
        }
    }
})